using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            #region Definizione del server
            // Definizione del server
            Service Server = new Service();
            Server.Url = "http://192.168.0.9/ProvaServerOPC/ProvaServerOPC.asmx";
            #endregion

            #region Chiamata al metodo GetStatus
            Console.WriteLine("---> Chiamata al metodo GetStatus <---");
            // Strutture dati coinvolte
            ServerStatus Status;
            ReplyBase Response;
            //Chiamata al metodo
            Response = Server.GetStatus("it", "Client Handle", out Status);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della GetStatus (Stato del server) <---");
            Console.WriteLine("Il product version del server : " + Status.ProductVersion);
            Console.WriteLine("Il server  partito alle: " + Status.StartTime);
            Console.WriteLine("Lo stato del server : " + Status.StatusInfo);
            Console.WriteLine("Il server supporta: " + Status.SupportedInterfaceVersions[0]);
            Console.WriteLine("Il server usa: " + Status.SupportedLocaleIDs[0]);
            Console.WriteLine("Il vendor info del server : " + Status.VendorInfo);

            Console.WriteLine("---> Stampa risultati della GetStatus (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);
            Console.ReadLine();
            #endregion

            #region Chiamata al metodo Read
            Console.WriteLine("---> Chiamata al metodo Read <---");
            // Strutture dati coinvolte
            RequestOptions Options;
            ReadRequestItemList ItemList;
            ReplyItemList RItemList;
            OPCError[] Errors;

            Options = new RequestOptions();
            Options.ClientRequestHandle = "Client Handle fornito dal client";
            Options.LocaleID = "it";
            Options.RequestDeadline = new DateTime(2008, 04, 06, 12, 30, 00);
            Options.RequestDeadlineSpecified = true;
            Options.ReturnDiagnosticInfo = true;
            Options.ReturnErrorText = true;
            Options.ReturnItemName = true;
            Options.ReturnItemPath = true;
            Options.ReturnItemTime = true;

            ItemList = new ReadRequestItemList();
            ItemList.ItemPath = "";
            ItemList.MaxAge = 10;
            ItemList.MaxAgeSpecified = true;
            ItemList.ReqType = new System.Xml.XmlQualifiedName();
            ItemList.Items = new ReadRequestItem[2];

            ItemList.Items[0] = new ReadRequestItem();
            ItemList.Items[0].ClientItemHandle = "Handle per l'item 0";
            ItemList.Items[0].ItemName = "Item Name per l'item 0";
            ItemList.Items[0].ItemPath = "Item Path per l'item 0";
            ItemList.Items[0].MaxAge = 100;
            ItemList.Items[0].MaxAgeSpecified = true;
            ItemList.Items[0].ReqType = new System.Xml.XmlQualifiedName();

            ItemList.Items[1] = new ReadRequestItem();
            ItemList.Items[1].ClientItemHandle = "Handle per l'item 1";
            ItemList.Items[1].ItemName = "Item Name per l'item 1";
            ItemList.Items[1].ItemPath = "Item Path per l'item 1";
            ItemList.Items[1].MaxAge = 100;
            ItemList.Items[1].MaxAgeSpecified = true;
            ItemList.Items[1].ReqType = new System.Xml.XmlQualifiedName();

            //Chiamata al metodo
            Response = Server.Read(Options, ItemList, out RItemList, out Errors);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della Read (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);

            Console.WriteLine("---> Stampa risultati della Read (Errors) <---");
            Console.WriteLine("L' ID dell'errore 0 : " + Errors[0].ID);
            Console.WriteLine("Il testo dell'errore 0 : " + Errors[0].Text);
            Console.WriteLine("L' ID dell'errore 1 : " + Errors[1].ID);
            Console.WriteLine("Il testo dell'errore 1 : " + Errors[1].Text);

            Console.WriteLine("---> Stampa risultati della Read (RItemList) <---");
            Console.WriteLine("La stringa riservata : " + RItemList.Reserved);
            Console.WriteLine("Client Handle per l'item 0 : " + RItemList.Items[0].ClientItemHandle);
            Console.WriteLine("Diagnostic info per l'item 0 : " + RItemList.Items[0].DiagnosticInfo);
            Console.WriteLine("L'item name per l'item 0 : " + RItemList.Items[0].ItemName);
            Console.WriteLine("L'item path per l'item 0 : " + RItemList.Items[0].ItemPath);
            Console.WriteLine("Il timestamp per l'item 0 : " + RItemList.Items[0].Timestamp);
            Console.WriteLine("Il timestamp  stato specificato? " + RItemList.Items[0].TimestampSpecified);
            Console.WriteLine("Il valore assunto dall'item 0 :  " + RItemList.Items[0].Value);

            Console.WriteLine("Client Handle per l'item 1 : " + RItemList.Items[1].ClientItemHandle);
            Console.WriteLine("Diagnostic info per l'item 1 : " + RItemList.Items[1].DiagnosticInfo);
            Console.WriteLine("L'item name per l'item 1 : " + RItemList.Items[1].ItemName);
            Console.WriteLine("L'item path per l'item 1 : " + RItemList.Items[1].ItemPath);
            Console.WriteLine("Il timestamp per l'item 1 : " + RItemList.Items[1].Timestamp);
            Console.WriteLine("Il timestamp  stato specificato? " + RItemList.Items[1].TimestampSpecified);
            Console.WriteLine("Il valore assunto dall'item 1 :  " + RItemList.Items[1].Value);
            Console.ReadLine();
            #endregion

            #region Chiamata al metodo Write
            Console.WriteLine("---> Chiamata al metodo Write <---");
            // Strutture dati coinvolte
            bool ReturnValuesOnReply;
            WriteRequestItemList WriteItemList;

            WriteItemList = new WriteRequestItemList();
            WriteItemList.ItemPath = "";
            WriteItemList.Items = new ItemValue[2];
            WriteItemList.Items[0] = new ItemValue();
            WriteItemList.Items[0].ClientItemHandle = "Client Item Handle per l'item 0";
            WriteItemList.Items[0].DiagnosticInfo = "Diagnostic infoper l'item 0";
            WriteItemList.Items[0].ItemName = "Item Name per l'item 0";
            WriteItemList.Items[0].ItemPath = "Item Path per l'item 0";
            WriteItemList.Items[0].Quality = new OPCQuality();
            WriteItemList.Items[0].ResultID = new System.Xml.XmlQualifiedName();
            WriteItemList.Items[0].Timestamp = new DateTime();
            WriteItemList.Items[0].TimestampSpecified = false;
            WriteItemList.Items[0].Value = "Value per l'item 0";
            WriteItemList.Items[0].ValueTypeQualifier = new System.Xml.XmlQualifiedName();


            WriteItemList.Items[1] = new ItemValue();
            WriteItemList.Items[1].ClientItemHandle = "Client Item Handle per l'item 1";
            WriteItemList.Items[1].DiagnosticInfo = "Diagnostic info per l'item 1";
            WriteItemList.Items[1].ItemName = "Item Name per l'item 1";
            WriteItemList.Items[1].ItemPath = "Item Path per l'item 1";
            WriteItemList.Items[1].Quality = new OPCQuality();
            WriteItemList.Items[1].ResultID = new System.Xml.XmlQualifiedName();
            WriteItemList.Items[1].Timestamp = new DateTime();
            WriteItemList.Items[1].TimestampSpecified = false;
            WriteItemList.Items[1].Value = "Value per l'item 1";
            WriteItemList.Items[1].ValueTypeQualifier = new System.Xml.XmlQualifiedName();

            ReturnValuesOnReply = false;

            //Chiamata al metodo
            Response = Server.Write(Options, WriteItemList, ReturnValuesOnReply, out RItemList, out Errors);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della Write (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);

            Console.WriteLine("---> Stampa risultati della Write (Errors) <---");
            Console.WriteLine("L' ID dell'errore 0 : " + Errors[0].ID);
            Console.WriteLine("Il testo dell'errore 0 : " + Errors[0].Text);
            Console.WriteLine("L' ID dell'errore 1 : " + Errors[1].ID);
            Console.WriteLine("Il testo dell'errore 1 : " + Errors[1].Text);

            Console.WriteLine("---> Stampa risultati della Write (RItemList) <---");
            Console.WriteLine("La stringa riservata : " + RItemList.Reserved);
            Console.WriteLine("Client Handle per l'item 0 : " + RItemList.Items[0].ClientItemHandle);
            Console.WriteLine("Diagnostic info per l'item 0 : " + RItemList.Items[0].DiagnosticInfo);
            Console.WriteLine("L'item name per l'item 0 : " + RItemList.Items[0].ItemName);
            Console.WriteLine("L'item path per l'item 0 : " + RItemList.Items[0].ItemPath);
            Console.WriteLine("Il timestamp per l'item 0 : " + RItemList.Items[0].Timestamp);
            Console.WriteLine("Il timestamp  stato specificato? " + RItemList.Items[0].TimestampSpecified);
            Console.WriteLine("Il valore assunto dall'item 0 :  " + RItemList.Items[0].Value);

            Console.WriteLine("Client Handle per l'item 1 : " + RItemList.Items[1].ClientItemHandle);
            Console.WriteLine("Diagnostic info per l'item 1 : " + RItemList.Items[1].DiagnosticInfo);
            Console.WriteLine("L'item name per l'item 1 : " + RItemList.Items[1].ItemName);
            Console.WriteLine("L'item path per l'item 1 : " + RItemList.Items[1].ItemPath);
            Console.WriteLine("Il timestamp per l'item 1 : " + RItemList.Items[1].Timestamp);
            Console.WriteLine("Il timestamp  stato specificato? " + RItemList.Items[1].TimestampSpecified);
            Console.WriteLine("Il valore assunto dall'item 1 :  " + RItemList.Items[1].Value);
            Console.ReadLine();
            #endregion

            #region Chiamata al metodo Subscribe
            // Strutture dati coinvolte
            SubscribeRequestItemList SubscribeItemList = new SubscribeRequestItemList();
            int SubscriptionPingRate = 100;
            SubscribeReplyItemList SubscribeRItemList;
            string ServerSubHandle;
            Response = Server.Subscribe(Options, SubscribeItemList, ReturnValuesOnReply, SubscriptionPingRate, 
                out SubscribeRItemList, out Errors, out ServerSubHandle);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della Subscribe (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);

            Console.WriteLine("---> Stampa risultati della Subscribe (Errors) <---");
            Console.WriteLine("L' ID dell'errore 0 : " + Errors[0].ID);
            Console.WriteLine("Il testo dell'errore 0 : " + Errors[0].Text);
            Console.WriteLine("L' ID dell'errore 1 : " + Errors[1].ID);
            Console.WriteLine("Il testo dell'errore 1 : " + Errors[1].Text);

            Console.WriteLine("---> Stampa risultati della Subscribe (RItemList) <---");
            Console.WriteLine("Il sampling rate  supportato? " + SubscribeRItemList.RevisedSamplingRateSpecified);
            Console.WriteLine("Il sampling rate supportato: " + SubscribeRItemList.RevisedSamplingRate);
            Console.WriteLine("Sampling rate supportato per l' item 0:  " + SubscribeRItemList.Items[0].RevisedSamplingRate);
            Console.WriteLine("Sampling rate  stato modificato?  " + SubscribeRItemList.Items[0].RevisedSamplingRateSpecified);
            Console.WriteLine("Il valore assunto dall'item 0 :  " + SubscribeRItemList.Items[0].ItemValue.Value);

            Console.WriteLine("Sampling rate supportato per l' item 1:  " + SubscribeRItemList.Items[1].RevisedSamplingRate);
            Console.WriteLine("Sampling rate  stato modificato?  " + SubscribeRItemList.Items[1].RevisedSamplingRateSpecified);
            Console.WriteLine("Il valore assunto dall'item 1 :  " + SubscribeRItemList.Items[1].ItemValue.Value);
            Console.ReadLine();
            #endregion

            #region Chiamata al metodo SubscriptionPolledRefresh
            // Strutture dati coinvolte
            string[] ServerSubHandles = new string[1];
            System.DateTime HoldTime = new DateTime();
            bool HoldTimeSpecified = true;
            int WaitTime = 100;
            bool ReturnAllItems = true;
            string[] InvalidServerSubHandles = new string[1];
            SubscribePolledRefreshReplyItemList[] PolledRefreshRItemList;
            bool DataBufferOverflow;
            
            Response = Server.SubscriptionPolledRefresh(Options, ServerSubHandles, HoldTime, HoldTimeSpecified, WaitTime, 
                ReturnAllItems, out InvalidServerSubHandles, out PolledRefreshRItemList, out Errors, out DataBufferOverflow);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della SubscriptionPolledRefresh (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);

            Console.WriteLine("---> Stampa risultati della SubscriptionPolledRefresh (Errors) <---");
            Console.WriteLine("L' ID dell'errore 0 : " + Errors[0].ID);
            Console.WriteLine("Il testo dell'errore 0 : " + Errors[0].Text);
            Console.WriteLine("L' ID dell'errore 1 : " + Errors[1].ID);
            Console.WriteLine("Il testo dell'errore 1 : " + Errors[1].Text);
            
            Console.WriteLine("---> Stampa risultati della SubscriptionPolledRefresh (InvalidServerSubHandles) <---");
            Console.WriteLine("I server subhandles non validi sono: " + InvalidServerSubHandles[0]);
            Console.WriteLine("C' stato overflow? " + DataBufferOverflow);


            Console.WriteLine("---> Stampa risultati della SubscriptionPolledRefresh (PolledRefreshRItemList) <---");
            Console.WriteLine("Valore item 0: " + PolledRefreshRItemList[0].Items[0].Value);
            Console.WriteLine("Valore item 1: " + PolledRefreshRItemList[0].Items[1].Value);
            #endregion

            #region Chiamata al metodo SubscriptionCancel
            string ClientRequestHandle = "";
            Server.SubscriptionCancel(ServerSubHandle, ref ClientRequestHandle);
            #endregion

            #region Chiamata al metodo Browse
            //Strutture dati coinvolte
            System.Xml.XmlQualifiedName[] PropertyNames = new System.Xml.XmlQualifiedName[1];
            string LocaleID = "it";
            string ItemPath = "";
            string ItemName = "";
            string ContinuationPoint = "";
            int MaxElementsReturned = 100;
            string ElementNameFilter = "";
            string VendorFilter = "";
            bool ReturnAllProperties = true;
            bool ReturnPropertyValues = true;
            bool ReturnErrorText = true;
            BrowseElement[] Elements = new BrowseElement[1];
            bool MoreElements;
            Response = Server.Browse(PropertyNames, LocaleID, ClientRequestHandle, ItemPath, ItemName, ref ContinuationPoint, 
                MaxElementsReturned, browseFilter.all, ElementNameFilter, VendorFilter, ReturnAllProperties, ReturnPropertyValues, 
                ReturnErrorText, out Elements, out Errors, out MoreElements);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della Browse (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);

            Console.WriteLine("---> Stampa risultati della Browse (Errors) <---");
            Console.WriteLine("L' ID dell'errore 0 : " + Errors[0].ID);
            Console.WriteLine("Il testo dell'errore 0 : " + Errors[0].Text);
            Console.WriteLine("L' ID dell'errore 1 : " + Errors[1].ID);
            Console.WriteLine("Il testo dell'errore 1 : " + Errors[1].Text);

            Console.WriteLine("---> Stampa risultati della Browse (MoreElements) <---");
            Console.WriteLine("Ci sono altri elementi? " + MoreElements);

            Console.WriteLine("---> Stampa risultati della Browse (Elements) <---");
            Console.WriteLine("Nome elemento: " + Elements[0].Name);
            Console.WriteLine("E' un item? " + Elements[0].IsItem);
            Console.WriteLine("Descrizione della prima propriet" + Elements[0].Properties[0].Description);
            
            #endregion

            #region Chiamata al metodo GetProperties
            //Strutture dati coinvolte

            ItemIdentifier[] ItemIDs = new ItemIdentifier[1];
            PropertyReplyList[] PropertyLists = new PropertyReplyList[1];

            Response = Server.GetProperties(ItemIDs, PropertyNames, LocaleID, ClientRequestHandle, ItemPath, 
                ReturnAllProperties, ReturnPropertyValues, ReturnErrorText, out PropertyLists, out Errors);

            //Stampa risultato della chiamata a funzione
            Console.WriteLine("---> Stampa risultati della GetProperties (Response) <---");
            Console.WriteLine("Il client request handle tornato : " + Response.ClientRequestHandle);
            Console.WriteLine("Messaggio ricevuto alle: " + Response.RcvTime);
            Console.WriteLine("Il server ha risposto alle: " + Response.ReplyTime);
            Console.WriteLine("Il server ha settato il locale a: " + Response.RevisedLocaleID);
            Console.WriteLine("Lo stato del server : " + Response.ServerState);

            Console.WriteLine("---> Stampa risultati della GetProperties (Errors) <---");
            Console.WriteLine("L' ID dell'errore 0 : " + Errors[0].ID);
            Console.WriteLine("Il testo dell'errore 0 : " + Errors[0].Text);
            Console.WriteLine("L' ID dell'errore 1 : " + Errors[1].ID);
            Console.WriteLine("Il testo dell'errore 1 : " + Errors[1].Text);

            Console.WriteLine("---> Stampa risultati della GetProperties (PropertyLists) <---");
            Console.WriteLine("Nome del primo item: " + PropertyLists[0].ItemName);
            Console.WriteLine("Propriet descrizione del primo item: " + PropertyLists[0].Properties[0].Description);
            #endregion
        }
    }
}